/*
 * Copyright (C) 1995,96 M. Hauber, Ch. Schneider, G. Caronni, R. Muchsel
 * See COPYING for more details
 */

#ifndef _SKIP_H_
#define _SKIP_H_

#define SKIP_DISCARD	-1	/* we rely on PROCESSED > QUEUED > DISCARD */
#define SKIP_QUEUED	0x00	/* don't change "DISCARD" -- is hard coded */
#define SKIP_PROCESSED	0x01
#ifdef __linux__
#define SKIP_P_AUTH	0x02 	/* bit flags or'ed with SKIP_PROCESSED */
#define SKIP_P_TUNNEL	0x04
#define SKIP_P_ENCRYPT	0x10
#define SKIP_P_DECRYPT	0x20
#else 				/* the other platforms cannot handle this yet */
#define SKIP_P_AUTH	0x00
#define SKIP_P_TUNNEL	0x00
#define SKIP_P_ENCRYPT	0x00
#define SKIP_P_DECRYPT	0x00
#endif

extern int skip_process(int dir, void *interface, void *header,
			void **pkt, struct memblk *old, struct memblk *new);

#endif /* _H_ */
