/**
 * This interface is designed to provide a common protocol for
 * converting an element's value to a predefined string format
 * @version none
 * @author Marcel Waldvogel
 */
 
public interface Parsing {
  /**
   * Set this object's value from a string
   */
  public abstract void parseFrom(String string);

  /**
   * Output this object's value to a string.
   * This is unlike the toString method, in that it doesn't contain
   * the class name, but instead outputs it in the a Sytax, ParseFrom
   * understands.
   * @see Object#toString
   */
  public abstract String parseTo();
}
